#include <string.h>
#include <iostream>
#include <fstream>
#include <math.h>
using namespace std;

const int MAXT = 50;
const int MAXS = 100;
const int MAXP = 100;
const int MAXN = 80;

struct Tratto {
  float startx;
  float starty;
  float endx;
  float endy;
  float tempo;
};

struct Percorso {
  char nome[MAXS];
  Tratto tr[MAXT];
  int numTr;
};

struct ArchivioPercorsi {
  Percorso per[MAXP];
  int numPer;
};

int carica(ArchivioPercorsi* pa, const char nomef[]);

void disegnaGrafico(const Percorso* pp);

float distanzaTotale(const ArchivioPercorsi* pa, const char n[]);

void stampaNomiOrd(const ArchivioPercorsi* pa);

int seleziona(const ArchivioPercorsi* pa, float ax, float ay, float bx, float by, Percorso v[]);


void menu(){
  cout << "-------------------------" << endl;
  cout << "1) carica" << endl;
  cout << "2) disegna grafico" << endl;
  cout << "3) distanza totale" << endl;
  cout << "4) stampa nomi ord." << endl;
  cout << "5) seleziona" << endl;
  cout << "6) esci" << endl;
  cout << "Scegli: ";
}

void stampaTratto(Tratto t) {
  cout << t.startx << ' ' << t.starty << ' ' << t.endx << ' ' << t.endy << ' ' << t.tempo << endl;
}

void stampaPercorso(const Percorso* pp) {
  cout << pp->nome << endl; 
  for(int i=0; i<pp->numTr; i++)
    stampaTratto(pp->tr[i]);
}

int main(){
  ArchivioPercorsi arc;
  arc.numPer = 0;

  int q;
  float d;
  char n[MAXS];
  char c;
  float ax, ay, bx, by;  
  Percorso v[MAXN];

  while(true) {
    menu();
    cin >> c;
    switch(c){
      case '1':
        cout << "Carico dal file input.txt" << endl;
        q = carica(&arc, "input.txt");
        cout << "Ho caricato " << q << " percorsi" << endl;
        cout << "Contenuto dell'archivio: " << endl;
        for(int i=0; i<arc.numPer; i++) {
          stampaPercorso(&arc.per[i]);
        }
        break;
      case '2':
        cout << "Inserisci l'indice dell'elemento da usare: ";
        cin >> q ;
        disegnaGrafico(&arc.per[q]);
        break;
      case '3':
        cout << "Inserisci il nome: ";
        cin >> n;
        d = distanzaTotale(&arc, n);
        cout << "Distanza totale: " << d << endl;
        break;
      case '4':
        stampaNomiOrd(&arc);
        break;
      case '5':
        cout << "Inserisci x dell'angolo in basso a sinistra: ";
        cin >> ax;
        cout << "Inserisci y dell'angolo in basso a sinistra: ";
        cin >> ay;
        cout << "Inserisci x dell'angolo in alto a destra: ";
        cin >> bx;
        cout << "Inserisci y dell'angolo in alto a destra: ";
        cin >> by;
        q = seleziona(&arc, ax, ay, bx, by, v);
        cout << "Sono stati selezionati " << q << " percorsi:" << endl;
        for(int i=0; i<q; i++)
          stampaPercorso(&v[i]);
        break;
      case '6':
        return 0;
    }
  }
}
